searchNodes=[{"doc":"The main interface to Tyyppi library. Usually, functions and macros presented is this module are enough to work with Tyyppi.","ref":"Tyyppi.html","title":"Tyyppi","type":"module"},{"doc":"Experimental: applies the local function given as an argument. Validates the arguments given and the result produced by the call. See apply/3 for details.","ref":"Tyyppi.html#apply/2","title":"Tyyppi.apply/2","type":"macro"},{"doc":"Experimental: applies the external function given as an argument in the form &amp;Module.fun/arity or anonymous function with arguments. Validates the arguments given and the result produced by the call. Examples: iex&gt; use Tyyppi ...&gt; Tyyppi.apply((atom() -&gt; binary()), ...&gt; fn a -&gt; to_string(a) end, [:foo]) {:ok, &quot;foo&quot;} ...&gt; result = Tyyppi.apply((atom() -&gt; binary()), ...&gt; fn -&gt; &quot;foo&quot; end, [:foo]) ...&gt; match?({:error, {:fun, _}}, result) true ...&gt; Tyyppi.apply((atom() -&gt; binary()), ...&gt; fn _ -&gt; 42 end, [&quot;foo&quot;]) {:error, {:args, [&quot;foo&quot;]}} ...&gt; Tyyppi.apply((atom() -&gt; binary()), ...&gt; fn _ -&gt; 42 end, [:foo]) {:error, {:result, 42}}","ref":"Tyyppi.html#apply/3","title":"Tyyppi.apply/3","type":"macro"},{"doc":"Returns true if the term passed as the second parameter is of type type. The first parameter is expected to be a type as in specs, e. g. atom() or GenServer.on_start(). See Tyyppi.T.of?/2 for details.","ref":"Tyyppi.html#of?/2","title":"Tyyppi.of?/2","type":"macro"},{"doc":"Returns true if the term passed as the second parameter is of type type. The first parameter is expected to be of type Tyyppi.T.t().Examples:iex&gt; use Tyyppi ...&gt; type = Tyyppi.parse(atom()) %Tyyppi.T{ definition: {:type, 0, :atom, []}, module: nil, name: nil, params: [], quoted: {:atom, [], []}, source: nil, type: :built_in } ...&gt; Tyyppi.of_type?(type, :ok) true ...&gt; Tyyppi.of_type?(type, 42) false ...&gt; type = Tyyppi.parse(GenServer.on_start()) ...&gt; Tyyppi.of_type?(type, {:error, {:already_started, self()}}) true ...&gt; Tyyppi.of_type?(type, :foo) false","ref":"Tyyppi.html#of_type?/2","title":"Tyyppi.of_type?/2","type":"function"},{"doc":"Parses the type as by spec and returns its Tyyppi.T representation. See Tyyppi.T.parse/1 for details.","ref":"Tyyppi.html#parse/1","title":"Tyyppi.parse/1","type":"macro"},{"doc":"Creates the typed struct with spec bound to each field.UsageSee Tyyppi.Example for the example of why and how to use Tyyppi.Struct.Exampleiex&gt; defmodule MyStruct do ...&gt; @type my_type :: :ok | {:error, term()} ...&gt; Tyyppi.Struct.defstruct foo: atom(), bar: GenServer.on_start(), baz: my_type() ...&gt; end iex&gt; types = MyStruct.types() ...&gt; types[:foo] %Tyyppi.T{ definition: {:type, 0, :atom, []}, module: nil, name: nil, params: [], source: nil, type: :built_in } ...&gt; types[:baz] %Tyyppi.T{ definition: {:type, 0, :union, [ {:atom, 0, :ok}, {:type, 0, :tuple, [ {:atom, 0, :error}, {:type, 0, :term, []}]}]}, module: Test.Tyyppi.Struct.MyStruct, name: :my_type, params: [], quoted: {{:., [], [Test.Tyyppi.Struct.MyStruct, :my_type]}, [], []}, source: :user_type, type: :type }DefaultsSince there is no place for default values in the struct declaration, where types are first class citizens, defaults might be specified through @defaults module attribute. Omitted fields there will be considered having nil default value.iex&gt; %Tyyppi.Example{} %Tyyppi.Example{ bar: :erlang.list_to_pid(&#39;&lt;0.0.0&gt;&#39;), baz: {:error, :reason}, foo: :default}Upsertsiex&gt; {ex, pid} = {%Tyyppi.Example{}, :erlang.list_to_pid(&#39;&lt;0.0.0&gt;&#39;)} iex&gt; Tyyppi.Example.update(ex, foo: :foo, bar: {:ok, pid}, baz: :ok) {:ok, %Tyyppi.Example{ bar: {:ok, :erlang.list_to_pid(&#39;&lt;0.0.0&gt;&#39;)}, baz: :ok, foo: :foo}} iex&gt; Tyyppi.Example.update(ex, foo: :foo, bar: {:ok, pid}, baz: 42) {:error, {:baz, :type}}Accessiex&gt; pid = :erlang.list_to_pid(&#39;&lt;0.0.0&gt;&#39;) iex&gt; ex = %Tyyppi.Example{foo: :foo, bar: {:ok, pid}, baz: :ok} iex&gt; put_in(ex, [:foo], :foo_sna) %Tyyppi.Example{ bar: {:ok, :erlang.list_to_pid(&#39;&lt;0.0.0&gt;&#39;)}, baz: :ok, foo: :foo_sna} iex&gt; put_in(ex, [:foo], 42) ** (ArgumentError) could not put/update key :foo with value 42; reason: validation failed ({:foo, :type})","ref":"Tyyppi.Struct.html","title":"Tyyppi.Struct","type":"module"},{"doc":"Puts the value to target under specified key, if passes validation","ref":"Tyyppi.Struct.html#put/3","title":"Tyyppi.Struct.put/3","type":"function"},{"doc":"Puts the value to target under specified key, if passes validation, raises otherwise","ref":"Tyyppi.Struct.html#put!/3","title":"Tyyppi.Struct.put!/3","type":"function"},{"doc":"Updates the value in target under specified key, if passes validation","ref":"Tyyppi.Struct.html#update/3","title":"Tyyppi.Struct.update/3","type":"function"},{"doc":"Updates the value in target under specified key, if passes validation, raises otherwise","ref":"Tyyppi.Struct.html#update!/3","title":"Tyyppi.Struct.update!/3","type":"function"},{"doc":"Process caching the loaded types information.Whether your application often uses the types information, it makes sense to cache it in a process state, because gathering it takes some time. In such a case your application should start this process in the application’s supervision tree, and call Tyyppi.Stats.rehash!/0 every time when the new module is compiled in the runtime.","ref":"Tyyppi.Stats.html","title":"Tyyppi.Stats","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Tyyppi.Stats.html#child_spec/1","title":"Tyyppi.Stats.child_spec/1","type":"function"},{"doc":"Rehashes the types information currently available in the system. This function should be called after the application has created a module in runtime for this module information to appear in the cache.","ref":"Tyyppi.Stats.html#rehash!/0","title":"Tyyppi.Stats.rehash!/0","type":"function"},{"doc":"Starts the cache process. The optional parameter might contain any payload that will be stored in the process’ state.If a payload has callback :: (-&gt; :ok) parameter, this function will be called every time the types information gets rehashed.","ref":"Tyyppi.Stats.html#start_link/1","title":"Tyyppi.Stats.start_link/1","type":"function"},{"doc":"Retrieves the type information for the type given.","ref":"Tyyppi.Stats.html#type/1","title":"Tyyppi.Stats.type/1","type":"function"},{"doc":"Retrieves all the types information currently available in the system.","ref":"Tyyppi.Stats.html#types/0","title":"Tyyppi.Stats.types/0","type":"function"},{"doc":"Function to be called upon rehashing. When arity is 0, the full new state would be passed, for arity 1, added and removed types would be passed, for arity 2, added, removed, and full state would be passed.","ref":"Tyyppi.Stats.html#t:callback/0","title":"Tyyppi.Stats.callback/0","type":"type"},{"doc":"Types information cache","ref":"Tyyppi.Stats.html#t:info/0","title":"Tyyppi.Stats.info/0","type":"type"},{"doc":"Raw type wrapper. All the macros exported by that module are available in Tyyppi. Require and use Tyyppi instead.","ref":"Tyyppi.T.html","title":"Tyyppi.T","type":"module"},{"doc":"Applies the function from the current module, validating input arguments and output.See apply/3 for details.","ref":"Tyyppi.T.html#apply/2","title":"Tyyppi.T.apply/2","type":"macro"},{"doc":"Experimental: applies the external function given as an argument in the form &amp;Module.fun/arity or anonymous function with arguments. Validates the arguments given and the result produced by the call.Only named types are supported at the moment.If the number of arguments does not fit the arity of the type, returns {:error, {:arity, n}} where n is the number of arguments passed.If arguments did not pass the validation, returns {:error, {:args, [arg1, arg2, ...]}} where argN are the arguments passed.If both arity and types of arguments are ok, evaluates the function and checks the result against the type. Returns {:ok, result} or {:error, {:result, result}} if the validation did not pass.Example:require Tyyppi.T Tyyppi.T.apply(MyModule.callback(), MyModule.on_info/1, foo: 2) #⇒ {:ok,[foo_squared: 4]} Tyyppi.T.apply(MyModule.callback(), MyModule.on_info/1, foo: :ok) #⇒ {:error, {:args, :ok}} Tyyppi.T.apply(MyModule.callback(), MyModule.on_info/1, []) #⇒ {:error, {:arity, 0}}","ref":"Tyyppi.T.html#apply/3","title":"Tyyppi.T.apply/3","type":"macro"},{"doc":"Returns true if the type definition was loaded, false otherwise.","ref":"Tyyppi.T.html#loaded?/1","title":"Tyyppi.T.loaded?/1","type":"function"},{"doc":"Returns true if the term passed as the second parameter is of type type.Examples:iex&gt; require Tyyppi.T ...&gt; Tyyppi.T.of?(atom(), :ok) true ...&gt; Tyyppi.T.of?(atom(), 42) false ...&gt; Tyyppi.T.of?(GenServer.on_start(), {:error, {:already_started, self()}}) true ...&gt; Tyyppi.T.of?(GenServer.on_start(), :foo) false","ref":"Tyyppi.T.html#of?/2","title":"Tyyppi.T.of?/2","type":"macro"},{"doc":"Parses the type as by spec and returns its Tyyppi.T representation.Example:iex&gt; require Tyyppi.T ...&gt; Tyyppi.T.parse(GenServer.on_start()) |&gt; Map.put(:source, nil) %Tyyppi.T{ definition: {:type, 704, :union, [ {:type, 0, :tuple, [{:atom, 0, :ok}, {:type, 704, :pid, []}]}, {:atom, 0, :ignore}, {:type, 0, :tuple, [ {:atom, 0, :error}, {:type, 704, :union, [ {:type, 0, :tuple, [{:atom, 0, :already_started}, {:type, 704, :pid, []}]}, {:type, 704, :term, []} ]} ]} ]}, module: GenServer, name: :on_start, params: [], source: nil, quoted: {{:., [], [GenServer, :on_start]}, [], []}, type: :type }","ref":"Tyyppi.T.html#parse/1","title":"Tyyppi.T.parse/1","type":"macro"},{"doc":"","ref":"Tyyppi.T.html#t:ast/0","title":"Tyyppi.T.ast/0","type":"type"},{"doc":"","ref":"Tyyppi.T.html#t:raw/0","title":"Tyyppi.T.raw/0","type":"type"},{"doc":"The type information in a human-readable format.For remote types, it’s gathered from Code.Typespec, for built-in like atom() ot’s simply constructed on the fly.","ref":"Tyyppi.T.html#t:t/0","title":"Tyyppi.T.t/0","type":"type"},{"doc":"Example of the structure defined with Tyyppi.Struct.defstruct/1The original code of this module follows:import Kernel, except: [defstruct: 1] import Tyyppi.Struct, only: [defstruct: 1] @typedoc &quot;The user type defined before `defstruct/1` declaration&quot; @type my_type :: :ok | {:error, term()} defstruct foo: atom(), bar: GenServer.on_start(), baz: my_type()","ref":"Tyyppi.Example.html","title":"Tyyppi.Example","type":"module"},{"doc":"Returns the field types of this struct as keyword of {field :: atom, type :: Tyyppi.T.t()} pairs.","ref":"Tyyppi.Example.html#types/0","title":"Tyyppi.Example.types/0","type":"function"},{"doc":"Updates the struct","ref":"Tyyppi.Example.html#update/2","title":"Tyyppi.Example.update/2","type":"function"},{"doc":"This function is supposed to be overwritten in the implementation in cases when custom validation is required.It would be called after all casts and type validations, if the succeeded","ref":"Tyyppi.Example.html#validate/1","title":"Tyyppi.Example.validate/1","type":"function"},{"doc":"The user type defined before defstruct/1 declaration","ref":"Tyyppi.Example.html#t:my_type/0","title":"Tyyppi.Example.my_type/0","type":"type"},{"doc":"The type describing this struct. This type will be used to validate upserts when called via Access and/or Tyyppi.Example.put/3, Tyyppi.Example.update/4.","ref":"Tyyppi.Example.html#t:t/0","title":"Tyyppi.Example.t/0","type":"type"},{"doc":"TyyppiLibrary bringing erlang typespecs to runtime.Provides on-the-fly type validation, typed structs with upserts validation and more.","ref":"getting-started.html","title":"Tyyppi","type":"extras"},{"doc":"Tyyppi allows the runtime validation of types, specified as specs. To use all the features, one should start Tyyppi.Stats process within the application supervision tree.Internally, the library keeps the types as instances of Tyyppi.T struct.Tyyppi.parse/1Accepts the type and returns back Tyyppi.T instance. It’s unlikely you’d need to call this macro directly.iex|tyyppi|1 ▶ Tyyppi.parse atom #⇒ %Tyyppi.T{ # definition: {:type, 0, :atom, []}, # module: nil, # name: nil, # params: [], # quoted: {:atom, [], []}, # source: nil, # type: :built_in # }Remote types are also supported, if they are known to the system. To get an access to remote types, one must start Tyyppi.Stats process by calling Tyyppi.Stats.start_link/1.iex|tyyppi|2 ▶ Tyyppi.parse GenServer.on_start #⇒ %Tyyppi.T{ # definition: {:type, 700, :union, # [ # {:type, 0, :tuple, [{:atom, 0, :ok}, {:type, 700, :pid, []}]}, # {:atom, 0, :ignore}, # {:type, 0, :tuple, # [ # {:atom, 0, :error}, # {:type, 700, :union, # [ # {:type, 0, :tuple, # [{:atom, 0, :already_started}, {:type, 700, :pid, []}]}, # {:type, 700, :term, []} # ]} # ]} # ]}, # module: GenServer, # name: :on_start, # params: [], # quoted: {{:., [], [GenServer, :on_start]}, [], []}, # source: &quot;.../lib/elixir/ebin/Elixir.GenServer.beam&quot;, # type: :type # }Tyyppi.of?/2Validates the term given as the second parameter against type given as the first parameter.iex|tyyppi|3 ▶ Tyyppi.of? GenServer.on_start(), {:ok, self()} #⇒ true iex|tyyppi|4 ▶ Tyyppi.of? GenServer.on_start(), :ok #⇒ falseTyyppi.of_type?/2The same as Tyyppi.of?/2 but it expects an instance of Tyyppy.T (as returned by Tyyppi.parse/1) as the first parameter.iex|tyyppi|5 ▶ type = Tyyppi.parse(GenServer.on_start) iex|tyyppi|6 ▶ Tyyppi.of_type? type, {:ok, self()} #⇒ trueTyyppi.apply/3Experimental accepts spec type, function and the list of arguments, checks whether the argument list conforms the spec, applies the function if so, checks the result against the spec and returns either {:ok, result} tuple or {:error, {reason, value}} tuple otherwise.See Tyyppi.apply/3 docs for examples and details.","ref":"getting-started.html#dealing-with-types","title":"Tyyppi - Dealing with Types","type":"extras"},{"doc":"Tyyppi provides the handy way to build typed structs. The struct declared with Tyyppi.Struct.defstruct/1 automatically declares the public type with all the fields properly declared, as well as provides the ability to introduce additional validations and casting on per-field basis. It also optionally exposes Access implementation that also would allow upserts if and only the casted value passed validations (both againts the type and a custom validator, if it was declared.)","ref":"getting-started.html#dealing-with-structs","title":"Tyyppi - Dealing with Structs","type":"extras"}]